#include <bits/stdc++.h>
using namespace std;


using ll = long long;

#define citers(c) c.begin(), c.end()


#pragma GCC optimize("Ofast")


static inline void _io_speedup [[maybe_unused]] ()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
}


int h, w, s;
ll row_sum[32768][15] = {{0}};
ll full_sum[32768] = {0};
ll mx_xy[15][15] = {{0}};


void exit_print_res(int col_state, int row_state)
{
	cout << "YES\n";
	int k = 0;
	for (int i = 0; i < 15; ++i) k += ((col_state >> i) & 1) + ((row_state >> i) & 1);
	cout << k << '\n';
	for (int i = 0; i < 15; ++i)
	{
		if ((row_state >> i) & 1) cout << "1 " << i + 1 << '\n';
		if ((col_state >> i) & 1) cout << "2 " << i + 1 << '\n';
	}
	exit(0);
}


int cur_cols_state;
void del_rows1(int j, int state, int cur_sum)
{
	if (j >= h) return;

	del_rows1(j + 1, state, cur_sum);

	int new_state = state | (1 << j);
	cur_sum -= row_sum[cur_cols_state][j];
	if (cur_sum == s) exit_print_res(cur_cols_state, new_state);
	del_rows1(j + 1, new_state, cur_sum);
}

int bp[2001], p[2001];

void del_rows2(int target)
{
	if (target < 0) return;
	if (target == 0) exit_print_res(cur_cols_state, 0);
	memset(bp, false, sizeof(int) * 2001);
	memset(p, false, sizeof(int) * 2001);
	bp[0] = true;
	p[0] = -1;
	bp[row_sum[cur_cols_state][0]] = true;
	p[row_sum[cur_cols_state][0]] = 0;
	for (int j = 1; j < h; ++j)
	{
		if (row_sum[cur_cols_state][j] == 0) continue;
		for (int w = 2000; w > 0; --w)
		{
			if (w - row_sum[cur_cols_state][j] >= 0)
			{
				bp[w] = bp[w - row_sum[cur_cols_state][j]];
				p[w] = j;
			}
		}
	}
	if (bp[target])
	{
		int cur = target;
		int mask = 0;
		while (cur > 0)
		{
			mask |= 1 << p[cur];
			cur -= row_sum[cur_cols_state][p[cur]];
		}
		exit_print_res(cur_cols_state, mask);
	}
}


void del_cols(int i, int state)
{
	if (i >= w)
	{
		cur_cols_state = state;
		if (full_sum[state] < 2000)
			del_rows2(full_sum[state] - s);
		else
			del_rows1(0, 0, full_sum[state]);
		return;
	}

	del_cols(i + 1, state);

	int new_state = state | (1 << i);
	for (int j = 0; j < h; ++j)
	{
		row_sum[new_state][j] = row_sum[state][j] - mx_xy[i][j];
		full_sum[new_state] += row_sum[new_state][j];
	}
	if (full_sum[new_state] == s) exit_print_res(new_state, 0);
	if (full_sum[new_state] < s) return;
	del_cols(i + 1, new_state);
}


int main()
{
	_io_speedup();

	cin >> h >> w;
	for (int j = 0; j < h; ++j)
	{
		for (int i = 0; i < w; ++i)
		{
			cin >> mx_xy[i][j];
			row_sum[0][j] += mx_xy[i][j];
		}
		full_sum[0] += row_sum[0][j];
	}
	cin >> s;

	if (full_sum[0] < s)
	{
		cout << "NO" << endl;
		return 0;
	}
	if (full_sum[0] == s) exit_print_res(0, 0);
	del_cols(0, 0);
	cout << "NO" << endl;
	return 0;
}