#include <bits/stdc++.h>
using namespace std;


using ll = long long;

#define citers(c) c.begin(), c.end()


static inline void _io_speedup [[maybe_unused]] ()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
}


inline int ceil_div(int l, int r) { return l / r + (l % r != 0); }

inline int f(int max_len, int m) { return ceil_div(max(0, max_len - m), m); }


int main()
{
	_io_speedup();

	int n, k, t;
	cin >> n >> k >> t;

	int __end = (t == 0) ? (1) : (n);
	for (int root = 0; root < __end; ++root)
	{
		int left_cnt = root, right_cnt = n - 1 - root;
		// l = cannot, r = can
		int l = 0, r = max(left_cnt, right_cnt);
		while (l + 1 < r)
		{
			int mid = (l + r) / 2;
			if ((f(left_cnt, mid) + f(right_cnt, mid)) <= k)
				r = mid;
			else
				l = mid;
		}
		cout << r << ' ';
	}
	cout << '\n';
	return 0;
}