#include <bits/stdc++.h>
using namespace std;


using ll = long long;

#define citers(c) c.begin(), c.end()


vector<int> prime_divisors(int num)
{
	vector<int> res;
	int _end = sqrt(num);
	for (int i = 2; i <= _end; ++i)
	{
		if (num % i == 0)
		{
			res.push_back(i);
			while (num % i == 0) num /= i;
		}
	}
	if (num != 1) res.push_back(num);
	return res;
}


int main()
{
	int n;
	cin >> n;
	vector<pair<int, int>> a(n);
	for (int i = 0; i < n; ++i)
	{
		cin >> a[i].first;
		a[i].second = i;
	}
	vector<int> color(n);
	sort(citers(a));
	set<int> first = {a[0].first};
	color[a[0].second] = 1;
	set<int> second;
	for (int i = 1; i < n; ++i)
	{
		vector<int> divs = prime_divisors(a[i].first);
		bool flag = true;
		if (first.count(a[i].first) == 0)
		{
			for (int d : divs)
			{
				if (first.count(a[i].first / d) != 0) flag = false;
			}
		}
		if (flag)
		{
			color[a[i].second] = 1;
			first.insert(a[i].first);
		}
		else
		{
			color[a[i].second] = 2;
			second.insert(a[i].first);
		}
	}
	for (int i : color) cout << i << ' ';
	cout << endl;
	return 0;
}