#include <bits/stdc++.h>


using ll = long long;

using namespace std;


static inline void _io_speedup [[maybe_unused]] ()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
}


vector<int> lefts[3], rights[3];
char ansc[] = {'.', 'X'};


int main()
{
	_io_speedup();

	int n, m;
	cin >> n >> m;
	for (int i = 0; i < 3; ++i)
	{
		lefts[i].resize(n);
		rights[i].resize(n);
	}

	for (int j = 0; j < n; ++j)
	{
		for (int i = 0; i < 6; ++i)
		{
			char c;
			cin >> c;
			if (i < 3)
				lefts[i][j] = c == 'X';
			else
				rights[5 - i][j] = c == 'X';
		}
	}

	int need_to_get_cnt = 0;
	int occupied_cnt = 0;
	for (int i = 0; i < 3; ++i)
	{
		for (int j = 0; j < n; ++j)
		{
			if (lefts[i][j])
			{
				need_to_get_cnt += !rights[i][j];
				rights[i][j] = true;
			}
			if (rights[i][j])
			{
				need_to_get_cnt += !lefts[i][j];
				lefts[i][j] = true;
			}
			if (lefts[i][j]) occupied_cnt += 2;
		}
	}
	int left_seats = (n * 6) - occupied_cnt;
	m -= need_to_get_cnt;
	if (m < 0 || m > left_seats || m % 2 == 1)
	{
		cout << "Impossible" << endl;
		return 0;
	}

	for (int j = 0; j < n; ++j)
	{
		for (int i = 0; i < 6; ++i)
		{
			if (i < 3)
			{
				if (m > 0 && (!lefts[i][j]))
				{
					lefts[i][j] = true;
					rights[i][j] = true;
					m -= 2;
				}
				cout << ansc[lefts[i][j]];
			}
			else
			{
				cout << ansc[rights[5 - i][j]];
			}
		}
		cout << '\n';
	}
	cout.flush();
	return 0;
}