#include <bits/stdc++.h>
using namespace std;


using ll = long long;

#define citers(c) c.begin(), c.end()


#pragma GCC optimize("Ofast")


static inline void _io_speedup [[maybe_unused]] ()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
}


int h, w, s;
ll row_sum[32768][15] = {{0}};
ll full_sum[32768] = {0};
ll mx_xy[15][15] = {{0}};


void exit_print_res(int col_state, int row_state)
{
	cout << "YES\n";
	int k = 0;
	for (int i = 0; i < 15; ++i) k += ((col_state >> i) & 1) + ((row_state >> i) & 1);
	cout << k << '\n';
	for (int i = 0; i < 15; ++i)
	{
		if ((row_state >> i) & 1) cout << "1 " << i + 1 << '\n';
		if ((col_state >> i) & 1) cout << "2 " << i + 1 << '\n';
	}
	exit(0);
}


int cur_cols_state;
void del_rows(int j, int state, int cur_sum)
{
	if (j >= h) return;

	del_rows(j + 1, state, cur_sum);

	int new_state = state | (1 << j);
	cur_sum -= row_sum[cur_cols_state][j];
	if (cur_sum == s) exit_print_res(cur_cols_state, new_state);
	del_rows(j + 1, new_state, cur_sum);
}


void del_cols(int i, int state)
{
	if (i >= w)
	{
		cur_cols_state = state;
		del_rows(0, 0, full_sum[state]);
		return;
	}

	del_cols(i + 1, state);

	int new_state = state | (1 << i);
	for (int j = 0; j < h; ++j)
	{
		row_sum[new_state][j] = row_sum[state][j] - mx_xy[i][j];
		full_sum[new_state] += row_sum[new_state][j];
	}
	if (full_sum[new_state] == s) exit_print_res(new_state, 0);
	if (full_sum[new_state] < s) return;
	del_cols(i + 1, new_state);
}


int main()
{
	_io_speedup();

	cin >> h >> w;
	for (int j = 0; j < h; ++j)
	{
		for (int i = 0; i < w; ++i)
		{
			cin >> mx_xy[i][j];
			if (mx_xy[i][j] < 0) exit(1);
			row_sum[0][j] += mx_xy[i][j];
		}
		full_sum[0] += row_sum[0][j];
	}
	cin >> s;

	if (full_sum[0] < s)
	{
		cout << "NO" << endl;
		return 0;
	}
	if (full_sum[0] == s) exit_print_res(0, 0);
	del_cols(0, 0);
	cout << "NO" << endl;
	return 0;
}