#include <bits/stdc++.h>
using namespace std;


using ll = long long;

#define citers(c) c.begin(), c.end()


vector<int> prime_divisors(int num)
{
	vector<int> res;
	int _end = sqrt(num);
	for (int i = 2; i <= _end; ++i)
	{
		if (num % i == 0)
		{
			res.push_back(i);
			while (num % i == 0) num /= i;
		}
	}
	if (num != 1) res.push_back(num);
	return res;
}


int main()
{
	int n;
	cin >> n;
	vector<pair<int, int>> a;
	vector<int> color(n);
	set<int> first;
	set<int> second;
	for (int i = 0; i < n; ++i)
	{
		int num;
		cin >> num;
		if (prime_divisors(num).size() == 1)
		{
			color[i] = 1;
			first.insert(num);
		}
		else
		{
			a.emplace_back(num, i);
		}
	}
	sort(citers(a));
	if (a[0].first == 1 && first.size() != 0)
	{
		color[a[0].second] = 2;
		second.insert(a[0].first);
	}
	else
	{
		first.insert(a[0].first);
		color[a[0].second] = 1;
	}
	for (int i = 1; i < (int)a.size(); ++i)
	{
		vector<int> divs = prime_divisors(a[i].first);
		bool flag = true;
		for (int d : divs)
		{
			if (first.count(a[i].first / d) != 0) flag = false;
		}
		for (int d : divs)
		{
			if ((flag == false) && second.count(a[i].first / d) != 0) throw runtime_error("wha?");
		}
		if (flag)
		{
			color[a[i].second] = 1;
			first.insert(a[i].first);
		}
		else
		{
			color[a[i].second] = 2;
			second.insert(a[i].first);
		}
	}
	for (int i : color) cout << i << ' ';
	cout << endl;
	return 0;
}