#include <bits/stdc++.h>
using namespace std;
 
 
using ll = long long;
 
#define citers(c) c.begin(), c.end()
 
 
vector<int> prime_divisors(int num)
{
	vector<int> res;
	int _end = sqrt(num);
	for (int i = 2; i <= _end; ++i)
	{
		if (num % i == 0)
		{
			res.push_back(i);
			while (num % i == 0) num /= i;
		}
	}
	if (num != 1) res.push_back(num);
	return res;
}


bool is_prime(int num)
{
	if (num <= 1) return false;
	int _end = sqrt(num);
	for (int i = 2; i <= _end; ++i)
	{
		if (num % i == 0) return false;
	}
	return true;
}
 
 
int main()
{
	int n;
	cin >> n;
	vector<pair<int, int>> a;
	int one_idx = -1;
	for (int i = 0; i < n; ++i)
	{
		int num;
		cin >> num;
		if (num == 1)
			one_idx = i;
		else
			a.emplace_back(num, i);
	}
	if (a.size() == 0)
	{
		cout << "wa";
		return 0;
	}
	vector<int> color(n);
	sort(citers(a));
	set<int> first = {a[0].first};
	color[a[0].second] = 1;
	int el = 0;
	for (int i = 1; i < (int)a.size(); ++i)
	{
		vector<int> divs = prime_divisors(a[i].first);
		bool flag = true;
		for (int d : divs)
		{
			if (first.count(a[i].first / d) != 0) flag = false;
		}
		if (flag)
		{
			color[a[i].second] = 1;
			first.insert(a[i].first);
		}
		else
		{
			color[a[i].second] = 2;
		}
	}
	if (one_idx != -1)
	{
		if (any_of(citers(first), is_prime))
			color[one_idx] = 2;
		else
			color[one_idx] = 1;
	}
	for (int i : color) cout << i << ' ';
	cout << endl;
	return 0;
}