#include <bits/stdc++.h>
using namespace std;


using ll = long long;

#define citers(c) c.begin(), c.end()


int main()
{
	ll n, m;
	cin >> n >> m;
	vector<pair<ll, ll>> bak(n);
	vector<ll> effective_time(n);
	for (ll i = 0; i < n; ++i) cin >> bak[i].first;
	for (ll i = 0; i < n; ++i) cin >> bak[i].second;
	sort(citers(bak));
	
	auto get_bak_cnt = [&](ll t) -> ll
	{
		ll res = 0;
		for (auto [alone, spread] : bak)
		{
			ll total = alone + spread;
			if (t < total)
			{
				if (t >= alone) ++res;
			}
			else
			{
				ll p = t - total + 1;
				if (p > 40) return numeric_limits<ll>::max();
				res += 1ll << p;
			}
		}
		return res;
	};

	ll l = 0, r = 1e11; // l - < m; r >= m
	while (l + 1 < r)
	{
		ll mid = (l + r) / 2;
		if (get_bak_cnt(mid) < m)
			l = mid;
		else
			r = mid;
	}
	if (get_bak_cnt(r) != m)
		cout << -1 << endl;
	else
		cout << r << endl;
	return 0;
}